package timer;

import javax.swing.*;


import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.IOException;
import java.net.URL;
import java.util.Timer;
import java.util.TimerTask;


public class timerPAF {


	public static void main(String[] args) {
		timerPAF programa = new timerPAF();
		programa.inicio();
	}

	public void inicio() {
    
		//Si el archivo no existe lo crea
		archivo.crearArchivo(FICHEROPROGRAMA);
		//Comprobamos que el archivo está vacío
		boolean vacio = archivo.archivoVacio(FICHEROPROGRAMA);
		
		/**
		 * si no está vacio, comprueba el número de elementos para instanciar un array
		 * y rellena el array exámenes
		 */
		if(!vacio) {
			int filas = archivo.comprobarNumeroelementos(FICHEROPROGRAMA);
			//Nombre del Paf, tiempo en minutos, hora de inicio
			examenes = new String[filas][3];
			arrayExamenes = archivo.rellenarArray(examenes,FICHEROPROGRAMA);

		} else {
			//Si está vacío. 
			//Rellenamos el archivo con los datos			
			archivo.RellenarArchivo(FICHEROPROGRAMA);
			arrayExamenes = archivo.rellenarArray(examenes,FICHEROPROGRAMA);
		}


		marco = new MarcoTimer();
		marco.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

	}



	class MarcoTimer extends JFrame {

		public MarcoTimer() {
			setBounds(600,300,400,300);
			add(new LaminaMarcoTimer());
			setTitle("PAF Timer");
			setResizable(false);
			//Añadir icono
			Toolkit miHardware = Toolkit.getDefaultToolkit();
			URL ruta_imagen = MarcoTimer.class.getResource("TimerPAF/src/images/ioc.ico");
			Image iocIcono = miHardware.getImage(ruta_imagen);
			setIconImage(iocIcono);
			//pack();	
			setAlwaysOnTop(false);
			setVisible(true);

		}
	}

	class LaminaMarcoTimer extends JPanel {

		public LaminaMarcoTimer() {

			setLayout(new BorderLayout());

			superior = new JPanel();
			central = new JPanel();
			inferior = new JPanel();
			
			font = new Font("Arial",Font.BOLD,16);

			combo = new JComboBox();
			for (int i=0; i<arrayExamenes.length;i++) {
				combo.addItem(arrayExamenes[i][0]);
			}

			tituloPAF = new JLabel("Asignatura : ");
			PAF = new JLabel("Asignatura");
			tituloTime = new JLabel("Tiempo que falta ");
			time = new JLabel("0");
			tituloHoraInicio = new JLabel("Hora de Inicio : ");
			horaInicio = new JLabel("00:00");
			JLabel minutos = new JLabel("Minutos");			
			estado = new JLabel("Parado");

			combo.setFont(font);

			tituloPAF.setFont(font);
			PAF.setFont(font);
			tituloTime.setFont(font);
			horaInicio.setFont(font);
			tituloHoraInicio.setFont(font);
			minutos.setFont(font);			
			estado.setFont(new Font("Arial",Font.BOLD,20));
			estado.setForeground(Color.RED);

			combo.addActionListener(new ActionListener() {

				@Override
				public void actionPerformed(ActionEvent e) {

					//Solo actuamos en el timer si está inicializado
					if (timer != null)
						timer.cancel();

					// TODO Auto-generated method stub
					for (int i=0; i<arrayExamenes.length;i++) {

						if(combo.getSelectedItem().equals(arrayExamenes[i][0])) {
							PAF.setText(arrayExamenes[i][0]);
							time.setText(arrayExamenes[i][1]);	
							horaInicio.setText(arrayExamenes[i][2]);
						}

					}


				}

			});

			//Construccion JToolBar
			JToolBar barraHerramientas = getToolBar();
			
			btEmpezar = new JButton("Empezar");
			btDetener = new JButton("Detener");
			
			time.setForeground(new Color(114, 183, 102));
			time.setFont(new Font("Arial",Font.BOLD,60));
			tituloPAF.setBounds(20, 10, 250, 50);
			PAF.setBounds(150, 10, 250, 50);
			tituloTime.setBounds(20, 70, 250, 50);
			time.setBounds(180, 70, 250, 50);
			minutos.setBounds(280, 70, 250, 50);
			tituloHoraInicio.setBounds(20, 120, 250, 50);
			horaInicio.setBounds(180, 120, 250, 50);
			estado.setBounds(280, 120, 250, 50);


			
			superior.add(combo);
			central.add(tituloPAF);
			central.add(PAF);
			central.add(tituloTime);
			central.add(time);

			central.add(tituloHoraInicio);
			central.add(horaInicio);
			central.add(minutos);
			central.add(estado);
			inferior.add(btEmpezar);
			inferior.add(btDetener);
			
			add(barraHerramientas,BorderLayout.WEST);
			add(superior,BorderLayout.NORTH);
			central.setLayout(null);
			add(central,BorderLayout.CENTER);
			add(inferior,BorderLayout.SOUTH);


			btEmpezar.addActionListener(new actuarTimer());
			btDetener.addActionListener(new actuarTimer());


		}

		private JToolBar getToolBar() {
			
			JToolBar barraHerramientas = new JToolBar(null, JToolBar.VERTICAL);
			barraHerramientas.setFloatable(false);
			barraHerramientas.setRollover(true);
			
			btAbrirArchivo = new JButton(new ImageIcon("src/images/verArchivo.png"));
			btAlwaysonTOP = new JButton(new ImageIcon("src/images/alwaysOnTop.png"));
		
			
			btAbrirArchivo.addActionListener(new ActionListener() {
				@Override
				public void actionPerformed(ActionEvent arg0) {
					// TODO Auto-generated method stub
					try {
						Desktop.getDesktop().open(FICHEROPROGRAMA);
					} catch (IOException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				}
			});
			
			btAlwaysonTOP.addActionListener(new ActionListener() {

				@Override
				public void actionPerformed(ActionEvent arg0) {
					// TODO Auto-generated method stub
					
					
					
					if (!marco.isAlwaysOnTop()) {
						
						marco.setAlwaysOnTop(true);
					} else {
						
						marco.setAlwaysOnTop(false);
					}
				}
			});
			
			
			
			btAbrirArchivo.setToolTipText("Abrir Archivo de texto");
			btAlwaysonTOP.setToolTipText("Quitar/Poner siempre encima");
			
			barraHerramientas.add(btAbrirArchivo);
			barraHerramientas.add(btAlwaysonTOP);
			
		
			return barraHerramientas;
		}
		

		private class actuarTimer implements ActionListener {

			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub
				PAFText = PAF.getText();
				time.setForeground(new Color(114, 183, 102));
				if (e.getSource().equals(btEmpezar)) {

					timer = new Timer();

					timer.scheduleAtFixedRate(new TimerTask() {

						int i = Integer.parseInt(time.getText());


						public void run() {

							estado.setForeground(new Color(114, 183, 102));
							estado.setText("Iniciado");

							String minutesStr = String.valueOf(i);

							time.setText(minutesStr);
							i--;

							if(i<=5) {
								time.setForeground(Color.RED);
							}

							if (i < 0 ) {
								timer.cancel();
								time.setText("Fin");
							}
						}
					}, 0, 60000);



				} else {
					timer.cancel();
					time.setText("Fin");
					estado.setForeground(Color.RED);
					estado.setText("Parado");
				}
			}
		} 					


	}

	
	private Font font;
	private JPanel superior,central, inferior;
	private JLabel tituloPAF,PAF,tituloTime,time,estado, tituloHoraInicio, horaInicio;
	private JComboBox combo;
	private JButton btEmpezar, btDetener, btAbrirArchivo,btAlwaysonTOP,btAñadirMas;
	private String PAFText;
	private int minutos;
	private Timer timer;
	static final String HOME = System.getProperty("user.home");
	private static final File FICHEROPROGRAMA = new File(HOME + File.separator + "Desktop"+ File.separator + "PafTimer.txt"); 
	static final UsoArchivo archivo = new UsoArchivo();
	private String[][] examenes;
	private String[][] arrayExamenes;
	private MarcoTimer marco;

}




